## libgtkada 0.2.1

=== Makefile ===
SHELL = /bin/sh

# INSTALL = install
# INSTALL_PROGRAM = $(INSTALL)
# INSTALL_DATA = $(INSTALL)

prefix = /usr/local
exec_prefix = $(prefix)
libdir = $(exec_prefix)/lib
infodir = $(prefix)/info
mandir = $(prefix)/man
man1dir = $(mandir)/man1
man3dir = $(mandir)man3
man1ext = .1
man3ext = .3

.SUFFIXES:
.SUFFIXES: .c .o .ads .adb .ali

.PHONY:
.PHONY: clean distclean mostlyclean maintainer-clean

c_objects = misc.o misc-gnat.o

TEST_LINK = test_link

CC = gcc
CFLAGS = -O2 -g -Wall
ALL_CFLAGS = $(CFLAGS) `gtk-config --cflags` -shared -fPIC

GNATCC = gcc
GNATFLAGS = -O2 -g -gnatg -gnata
ALL_GNATFLAGS = $(GNATFLAGS) -shared -fPIC

GNATMAKE = gnatmake
GNATMAKEFLAGS = $(GNATFLAGS)
GNATMAKELDFLAGS = -largs `gtk-config --libs` $(c_objects) -lgtkada

ARFLAGS = r

RANLIB = ranlib

all: libgtkada.so libgtkada.a testgtk

libgtkada.so:: $(TEST_LINK).o $(c_objects)
	$(CC) -shared -Wl,-soname,libgtkada.so -o libgtkada.so g*.o $(c_objects) `gtk-config --libs` -lc -lm

libgtkada.a::
	$(AR) $(ARFLAGS) libgtkada.a g*.o $(c_objects)
	if [ -f /usr/bin/$(RANLIB) -o -f /bin/$(RANLIB) ]; then \
	  $(RANLIB) libgtkada.a; \
	fi \

testgtk::
	$(MAKE) -C testgtk

$(TEST_LINK).o::
	test -f $(TEST_LINK).adb || perl ./create_test_link.pl > $(TEST_LINK).adb
	$(GNATMAKE) -c $(TEST_LINK) -shared -fPIC $(GNATFLAGS)

main: main.adb test.adb test.ads libgtkada.so
	$(GNATMAKE) $@ $(GNATMAKEFLAGS) $(GNATMAKELDFLAGS) 

install: libgtkada.a libgtkada.so
	@echo To Install, copy libgtkada.a *.ads *.ali to a new directory
	@echo and then do a 'chmod a-w *.ali' so that Gnat will not
	@echo try to recompile your files

uninstall:

install-strip:

clean:
	-${RM} *.o *.ali *~ main b_main.c core
	-${RM} libgtkada.a libgtkada.so
	-${RM} $(TEST_LINK) b_$(TEST_LINK).c $(TEST_LINK).adb
	-${RM} .\#*
	-cd testgtk && make clean

distclean: clean

mostlyclean: clean

maintainer-clean: clean


TAGS: ;

info: ;

dvi: ;

dist: ;

check: ;

installcheck: ;

installdirs: ;

.c.o:
	$(CC) -c $(ALL_CFLAGS) $<
.ads.o:
	$(CC) -c $(ALL_GNATFLAGS) $<

.adb.o:
	$(CC) -c $(ALL_GNATFLAGS) $<

=== testgtk/Makefile ===
SHELL = /bin/sh

# INSTALL = install
# INSTALL_PROGRAM = $(INSTALL)
# INSTALL_DATA = $(INSTALL)

prefix = /usr/local
exec_prefix = $(prefix)
libdir = $(exec_prefix)/lib
infodir = $(prefix)/info
mandir = $(prefix)/man
man1dir = $(mandir)/man1
man3dir = $(mandir)man3
man1ext = .1
man3ext = .3

.SUFFIXES:
.SUFFIXES: .c .o .ads .adb .ali

.PHONY:
.PHONY: clean distclean mostlyclean maintainer-clean

target = testgtk

CC = gcc
CFLAGS = -O2 -g -Wall
ALL_CFLAGS = $(CFLAGS) `gtk-config --cflags`

GNATCC = gcc
ALL_GNATFLAGS = $(GNATFLAGS) -I.. -g

GNATMAKE = gnatmake
GNATMAKEFLAGS = $(ALL_GNATFLAGS)
GNATMAKELDFLAGS = `gtk-config --libs` ../libgtkada.a
GNATMAKELDFLAGS_STATIC = `gtk-config --prefix`/lib/libgtk.a \
   `gtk-config --prefix`/lib/libglib.a \
   `gtk-config --libs | sed 's/-lglib//' | sed 's/-lgtk//'` ../libgtkada.a
#MALLOC_FLAGS= ../debug/wrap.o -Wl,--wrap=malloc -Wl,--wrap=free -Wl,--wrap=strdup
MALLOC_FLAGS=


all: $(target)

$(target): ../*.ad[sb] *.ad[sb]
	$(GNATMAKE) $(GNATMAKEFLAGS) $(target) -largs $(GNATMAKELDFLAGS)

static: ../*.ad[sb] *.ad[sb]
	$(GNATMAKE) $(GNATMAKEFLAGS) $(target) -largs $(MALLOC_FLAGS) $(GNATMAKELDFLAGS_STATIC)


install: ;

uninstall: ;

install-strip: ;

clean:
	-${RM} *.o *.ali *~ testgtk b_testgtk.c core
	-${RM} .\#*

distclean: clean

mostlyclean: clean

maintainer-clean: clean


TAGS: ;

info: ;

dvi: ;

dist: ;

check: ;

installcheck: ;

installdirs: ;

.adb.o:
	$(CC) -c $(ALL_GNATFLAGS) $<
.ads.o:
	$(CC) -c $(ALL_GNATFLAGS) $<

## libgtkada 1.2.4

=== docs/Makefile ===
all: gtkada.texi
	tex gtkada.texi
	texindex gtkada.cp
	tex gtkada.texi
	dvips gtkada.dvi -o gtkada.ps
	perl ./texi2html -menu -monolithic gtkada.texi
	makeinfo --force -o gtkada.info gtkada.texi
	makeinfo --force --no-headers --no-split -o gtkada.txt gtkada.texi
	-$(RM) *.aux *.cp *.cps *.dvi *.fn *.ky *.log *.pg *.toc *.tp *.vr

clean:
	-$(RM) gtkada.aux gtkada.cp gtkada.dvi gtkada.fn gtkada.html gtkada.info*
	-$(RM) gtkada.ky gtkada.log gtkada.pg gtkada.toc gtkada.tp gtkada.vr
	-$(RM) texput.log gtkada.ps gtkada.txt

distclean:
	-$(RM) gtkada.ps

=== docs/slides/Makefile ===
all:
	latex gtkada-presentation.tex
	dvips -o gtkada-presentation.ps gtkada-presentation.dvi
	-$(RM) gtkada-presentation.dvi
	-$(RM) gtkada-presentation.log
	-$(RM) gtkada-presentation.aux

clean:
	-$(RM) gtkada-presentation.dvi
	-$(RM) gtkada-presentation.log
	-$(RM) gtkada-presentation.aux

distclean: clean
	-$(RM) gtkada-presentation.ps

## libgtkada 1.2.12

=== examples/Makefile ===
DIRECTORIES=base_widget \
  composite_widget      \
  doublebuffer          \
  documentation         \
  dynamic_cast          \
  editor                \
  gtk_examples          \
  tutorial              \
  handlers

SHELL=sh

all: ${DIRECTORIES}
	@for file in ${DIRECTORIES}; do \
	  make -C $${file} all; \
	done

clean::
	@for file in ${DIRECTORIES}; do \
	  make -C $${file} clean; \
	done

=== examples/base_widget/Makefile ===
all:
	gnatmake -g main `gtkada-config`
run:
	./main

clean: 
	${RM} main *.o *.ali b_main.c b~*

=== examples/calendar_combo/Makefile ===
main::
	gnatmake -g main `gtkada-config`

clean::
	${RM} *.o *.ali b~* main

=== examples/composite_widget/Makefile ===
all:
	gnatmake main `gtkada-config`
run:
	./main

clean: 
	${RM} main *.o *.ali

=== examples/documentation/Makefile ===
EXEC=contextual banner toggle glist_traverse tooltips clist draw

all: ${EXEC}

${EXEC}::
	gnatmake -g $@ `gtkada-config`

clean::
	${RM} *.o *.ali b~* ${EXEC}

=== examples/doublebuffer/Makefile ===
all: parameters anim anim2

parameters::
	gnatmake -gnatwuwl parameters `gtkada-config`

anim::
	gnatmake -gnatwuwl anim `gtkada-config`

anim2::
	gnatmake -gnatwuwl anim2 `gtkada-config`

clean:
	${RM} *.o *.ali anim parameters anim2

=== examples/dynamic_cast/Makefile ===
all:
	gnatmake dynamic `gtkada-config`

clean:
	${RM} *.o *.ali b~* dynamic

=== examples/editor/Makefile ===
all:
	gnatmake gladeedit `gtkada-config`
run:
	./gladeedit

clean: 
	${RM} gladeedit *.o *.ali

=== examples/gtk_examples/Makefile ===
EXAMPLES=scribble

all: ${EXAMPLES}

scribble::
	gnatmake -g $@ `gtkada-config`
clean::
	${RM} *.o *.ali scribble b~*

=== examples/handlers/Makefile ===
all: delete_event specific_tips.o general_tips.o

delete_event:
	gnatmake delete_event `gtkada-config`

specific_tips.o:
	gnatmake -c specific_tips `gtkada-config`

general_tips.o:
	gnatmake -c general_tips `gtkada-config`

clean:
	${RM} *.o *.ali b~* delete_event

=== examples/powergnu/Makefile ===
CFLAGS = -g -O2

EXEC = power

all: $(EXEC)

power: force
	gnatmake -m -gnatwu $(CFLAGS) $(EXEC) `gtkada-config`

force:

clean:
	rm -f *.o *.ali *~ b~* $(EXEC)

=== examples/tutorial/gtkdial/Makefile ===
all: force
	gnatmake dial_test `gtkada-config`
clean: 
	rm -f *.o *~ *.ali dial_test
force:

## libgtkada 2.24.0

=== debian/changelog ===
libgtkada (2.24.0-2) unstable; urgency=low

  * debian/rules (build): do nothing.  This makes debian/rules compatible
    with architecture-dependent-only and architecture-independent-only
    builds (dpkg-buildpackage -B, -A).

 -- Ludovic Brenta <lbrenta@debian.org>  Wed,  7 Dec 2011 22:28:38 +0100

libgtkada (2.24.0-1) unstable; urgency=low

  [Nicolas Boulenguez]
  * New upstream release.
  * Rename the source package from libgtkada2 to libgtkada.
  * Package renamings pursuant to Debian Policy for Ada:
    libgnomeada2.14.2      -> libgnomeada2.24.0
    libgnomeada2.14.2-dbg  -> libgnomeada-dbg
    libgnomeada2.14.2-dev  -> libgnomeada2.24.0-dev
    libgtkada-gl2.14.2     -> libgtkglada2.24.0
    -                      -> libgtkglada-dbg       (new package)
    -                      -> libgtkglada2.24.0-dev (new package)
    libgtkada-glade2.14.2  -> (removed, support dropped upstream)
    libgtkada2-bin         -> libgtkada-bin
    libgtkada2-doc         -> libgtkada-doc
    libgtkada2.14.2        -> libgtkada2.24.0
    libgtkada2.14.2-dbg    -> libgtkada-dbg  
    libgtkada2.14.2-dev    -> libgtkada2.24.0-dev
  * Build with gnat-4.6.
  * Switch to dpkg-source 3.0 (quilt) format
  * control: (Homepage) added
     (Architecture) "any" instead of an explicit list
     (Section) avoided redundancy between source and binaries
     (Standard-Versions) 3.9.2
     Conflicts/Replaces removed with gcc change, due to debian-ada-policy.
  * copyright: DEP-5
  * patches: DEP-3
  * lintian override: GNAT needs an executable stack
  * watch: explains why uscan won't work.
  * doc-base registrations
  * patch to compile with hardening flags, new dpkg default.
  * bypass upstream build system, that was not intended to build
    two versions of the libraries at the same time.  Closes: #585611.

  [Ludovic Brenta]
  * control (Uploaders): add Nicolas.
    (DM-Upload-Allowed): yes.

 -- Ludovic Brenta <lbrenta@debian.org>  Tue,  6 Dec 2011 23:31:12 +0100

libgtkada2 (2.14.2-5) unstable; urgency=low

   * Interim upload before the transition to gnat-4.6.
   * debian/gnomeada2.gpr: correct an embarrassing thinko.  Closes: #646115.
   * debian/control (Build-Depend, Depend): remove gnat, which has
     transitioned to 4.6 and b-d on gnat-4.4 instead.

 -- Ludovic Brenta <lbrenta@debian.org>  Fri, 21 Oct 2011 22:48:13 +0200

libgtkada2 (2.14.2-4) unstable; urgency=low

  * debian/patch/example_makefiles.patch: new.  Thanks, Olivier Henley.
  * debian/rules (configure-stamp): correct the paths. Closes: #587533.

 -- Ludovic Brenta <lbrenta@debian.org>  Thu,  8 Jul 2010 10:55:03 +0200

libgtkada2 (2.14.2-3) unstable; urgency=low

  * debian/control (Architecture): add armel.  Closes: #568442.
    (Standards-Version): bump to 3.8.4 with no changes required.
    (*-dev): depend on gnat, ada-compiler.
    (*-doc, *-dbg, *-bin): suggest gnat, ada-compiler.
    (*-bin): recommend glade, not glade-2.
             Change the short description (lintian warning).
    (XS-VCS-*): replace with VCS-* (lintian warning).
    (Depends): add ${misc:Depends} everywhere (lintian warning).

  * debian/rules:
    (libgtkada2.14.2-dev): generate gtkada.gpr and gnomeada.gpr
    from gtkada2.gpr and gnomada2.gpr. Closes: #580118.
    (binary-arch): fix a thinko (lintian warning).

  * Fix lintian errors:
    ancient-autotools-helper-file config.guess 2001-09-04
    ancient-autotools-helper-file config.sub 2001-09-04
    - debian/control (Build-Depends): add autotools-dev.
    - debian/rules (clean): delete the two files.
      (configure-stamp): symlink them from /usr/share/misc, provided by
      autotools-dev.
  See also #585611.

 -- Ludovic Brenta <lbrenta@debian.org>  Sat, 12 Jun 2010 12:59:08 +0200

libgtkada2 (2.14.2-2) unstable; urgency=low

  [Nicolas Boulenguez]
  * debian/patches/02-commands.patch: Call gate2-in.exe in the location
    where debian/rules installs it.

 -- Ludovic Brenta <lbrenta@debian.org>  Sat, 24 Apr 2010 11:20:38 +0200

libgtkada2 (2.14.2-1) unstable; urgency=low

  [Olivier Scalbert]
  * New upstream version taken from Subversion revision 149669
    (gtkada-2.14.2-branchpoint).  Closes: #542417.
  * debian/patches/rename_gdialog_to_gtkada-dialog.patch: remove, merged upstream.
  * debian/patches/02-commands.patch,
    debian/patches/04-testgtk.patch,
    debian/patches/gtkada-config.patch,
    debian/patches/no_gtkextra.patch: adjust to new upstream release.
  * Do not built against libgtk+2.0-extra.  Closes: #534872.

  [Ludovic Brenta]
  * Migrate to gnat-4.4.  Closes: #560177.
  * debian/control (Architectures): remove alpha (see http://gcc.gnu.org/PR42073).
    (Section): move -dbg packages to debug.
    (Description): s/Ada 95/Ada/g.
    (Build-Depends): move some dependencies to...
    (Build-Depends-Indep): here.  Also add texlive-fonts-recommended and
    texlive-latex-base, needed for proper generation of the documentation.
  * -dev package renamings per Debian Policy for Ada:
    libgtkada2-dev          -> libgtkada2.14.2-dev
    libgnomeada2-dev        -> libgnomeada2.14.2-dev
  * Shared library package renamings due to new soname:
    libgtkada2.12           -> libgtkada2.14.2
    libgnomeada2.12         -> libgnomeada2.14.2
    libgtkada-glade2.12     -> libgtkada-gl2.14.2
    libgtkada-gl2.12        -> libgtkada-gl2.14.2
  * Debugging symbols package renamings due to new soname:
    libgtkada2.12-dbg       -> libgtkada2.14.2-dbg
    libgnomeada2.12-dbg     -> libgnomeada2.14.2-dbg
  * debian/rules:
    - extract aliversion and soversion from debian/control.
    - convert .gif to .png for inclusion in the PDF version of the doc.
    - separate build-arch from build-indep to support dpkg-buildpackage -A and -B.
  * debian/patches/compiler_options.patch: build without -fstack-check which
    is broken in gnat-4.4 on x86 (see http://gcc.gnu.org/PR20548).
  * debian/patches/sonames.patch: use the full three-part version number as
    the soversion.
  * debian/patches/01-doc.patch:


=== debian/control ===
Source: libgtkada
Section: libs
Priority: optional
Maintainer: Ludovic Brenta <lbrenta@debian.org>
Uploaders: Nicolas Boulenguez <nicolas.boulenguez@free.fr>
DM-Upload-Allowed: yes
Build-Depends: debhelper (>= 8.9.8), dpkg-dev (>= 1.16.1),
 gnat, gnat-4.6, gprbuild,
 libgnomeui-dev,
 libbonoboui2-dev,
 libgtk2.0-dev (>= 2.24.0),
 libgdk-pixbuf2.0-dev,
 libcairo2-dev,
 libpango1.0-dev,
 libglib2.0-dev,
 libx11-dev,
 libgl1-mesa-dev
Build-Depends-Indep: texinfo, texlive-fonts-recommended,
 texlive-generic-recommended, texlive-latex-base,
 transfig, netpbm, ghostscript
Standards-Version: 3.9.2
Homepage: http://libre.adacore.com/libre/tools/gtkada
Vcs-Browser: http://www.ada-france.org:8081/branch/changes/org.debian.libgtkada2
Vcs-Mtn: www.ada-france.org org.debian.libgtkada2

Package: libgtkada2.24.0-dev
Section: libdevel
Architecture: any
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends}
Depends: gnat, gnat-4.6, ada-compiler,
 libgtkada2.24.0 (=${binary:Version}),
 libgtkada-bin (=${binary:Version}),
 libcairo2-dev,
 libgdk-pixbuf2.0-dev,
 libglib2.0-dev,
 libgtk2.0-dev,
 libpango1.0-dev,
 libx11-dev,
 ${misc:Depends}
Suggests: libgnomeada2.24.0-dev (=${binary:Version}),
 libgtkglada2.24.0-dev (=${binary:Version}),
 libgtkada-doc (=${binary:Version})
Description: Ada binding for the GTK+ GUI (development files)
 GtkAda is a library that allows programmers to write GTK+ applications in the
 Ada programming language.
 .
 This package contains the development files and static libraries.

Package: libgnomeada2.24.0-dev
Section: libdevel
Architecture: any
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends}
Depends: gnat, gnat-4.6, ada-compiler,
 libgtkada2.24.0-dev (=${binary:Version}),
 libgnomeada2.24.0 (=${binary:Version}),
 libgnomeui-dev, libbonoboui2-dev,
 ${misc:Depends}
Suggests: libgtkada-doc (=${binary:Version})
Description: Ada binding for the GNOME GUI (development files)
 GtkAda is a library that allows programmers to write GTK+ applications in the
 Ada programming language.
 .
 This package contains the development files and static libraries for
 GNOME extensions.

Package: libgtkglada2.24.0-dev
Section: libdevel
Architecture: any
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends}
Depends: gnat, gnat-4.6, ada-compiler,
 libgtkada2.24.0-dev (=${binary:Version}),
 libgtkglada2.24.0 (=${binary:Version}),
 libgl1-mesa-dev,
 ${misc:Depends}
Suggests: libgtkada-doc (=${binary:Version})
Description: Ada binding for GTK+ OpenGL extensions (development files)
 GtkAda is a library that allows programmers to write GTK+ applications in the
 Ada programming language.
 .
 This package contains the development files and static libraries for
 the OpenGL extensions.

Package: libgtkada-dbg
Section: debug
Priority: extra
Architecture: any
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends}
Depends: libgtkada2.24.0 (=${binary:Version}), ${misc:Depends}
Recommends: gdb (>= 6.8), libgtkada2.24.0-dev (=${binary:Version})
Suggests: gnat, ada-compiler
Description: Ada binding for the GTK+ GUI (debugging symbols)
 GtkAda is a library that allows programmers to write GTK+ applications in the
 Ada programming language.
 .
 This package contains the debugging symbols.

Package: libgnomeada-dbg
Section: debug
Priority: extra
Architecture: any
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends}
Depends: libgnomeada2.24.0 (=${binary:Version}), ${misc:Depends}
Recommends: gdb (>= 6.8), libgnomeada2.24.0-dev (=${binary:Version})
Suggests: gnat, ada-compiler
Description: Ada binding for the GNOME GUI (debugging symbols)
 GtkAda is a library that allows programmers to write GTK+ applications in the
 Ada programming language.
 .
 This package contains the debugging symbols for the GNOME extensions.

Package: libgtkglada-dbg
Section: debug
Priority: extra
Architecture: any
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends}
Depends: libgtkglada2.24.0 (=${binary:Version}), ${misc:Depends}
Recommends: gdb (>= 6.8), libgtkglada2.24.0-dev (=${binary:Version})
Suggests: gnat, ada-compiler
Description: Ada binding for GTK+ OpenGL extensions (debugging symbols)
 GtkAda is a library that allows programmers to write GTK+ applications in the
 Ada programming language.
 .
 This package contains the debugging symbols for the OpenGL extensions.

Package: libgtkada2.24.0
Architecture: any
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends}
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: Ada binding for the GTK+ GUI (dynamic library)
 GtkAda is a library that allows programmers to write GTK+ applications in the
 Ada programming language.
 .
 This library will let you run Ada applications compiled with GTK+.

Package: libgnomeada2.24.0
Architecture: any
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends}
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: Ada binding for the GNOME GUI (dynamic library)
 GtkAda is a library that allows programmers to write GTK+ applications in the
 Ada programming language.
 .
 This library will let you run Ada applications compiled with GNOME.

Package: libgtkglada2.24.0
Architecture: any
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends}
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: Ada binding for GTK+ OpenGL extensions (dynamic library)
 GtkAda is a library that allows programmers to write GTK+ applications in the
 Ada programming language
 .
 This library will let you run GtkAda applications compiled with OpenGL
 support.

Package: libgtkada-bin
Section: devel
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Suggests: gnat, ada-compiler, libgtkada-doc (=${binary:Version})
Description: Ada binding for the GTK+ GUI (development utilities)
 GtkAda is a library that allows programmers to write GTK+ applications in the
 Ada programming language.
 .
 This package contains development utilities (gtkada-dialog and gtkada-config).

Package: libgtkada-doc
Section: doc
Architecture: all
Depends: ${misc:Depends}
Suggests: gnat, ada-compiler
Description: Ada binding for the GTK+ GUI (documentation)
 GtkAda is a library that allows programmers to write GTK+ applications in the
 Ada programming language.
 .
 This package contains the User's Guide and Reference Manual for GtkAda, in
 HTML, Info, PDF and ASCII formats.

=== debian/rules ===
#!/usr/bin/make -f
# debian/rules for libgtkada
# Copyright (c) 2003-2011 Ludovic Brenta <lbrenta@debian.org>
# Copyright (c) 2011 Nicolas Boulenguez <nicolas.boulenguez@free.fr>
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 3 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# The full text of the GNU General Public License is in the file
# /usr/share/common-licenses/GPL-3 on Debian systems.

# Uncomment for debugging settings.
# DEB_BUILD_OPTIONS := noopt
# GPRBUILD_VERBOSE := -v
# SKIP_STATIC := true
# export DH_VERBOSE := 1

######################################################################

.SUFFIXES:

binary binary-arch binary-indep build-arch build-indep clean:
	dh $@

build: # do nothing

# Ignore upstream's build system
override_dh_auto_configure:

# In order to ease cleaning and avoid name conflicts, put as many
# generated files as possible into a specific directory.
# debian/*.gpr projects rely on this name.
GEN_DIR := debian/build

$(GEN_DIR):
	mkdir $@

override_dh_auto_clean::
	dh_clean
	rm -f -r $(GEN_DIR)

######################################################################

DEB_HOST_MULTIARCH := $(shell dpkg-architecture -qDEB_HOST_MULTIARCH)

GPRBUILD := gprbuild \
   -cargs -Wall -fstack-check \
   -cargs:Ada -gnatE -gnatVa -gnata -gnatf -gnatn -gnato \
      $(shell DEB_BUILD_MAINT_OPTIONS=hardening=-format \
              DEB_BUILD_OPTIONS="$(DEB_BUILD_OPTIONS)" dpkg-buildflags --get CFLAGS) \
   -cargs:C -Wextra \
      $(shell DEB_BUILD_OPTIONS="$(DEB_BUILD_OPTIONS)" dpkg-buildflags --get CFLAGS) \
      $(shell pkg-config --cflags-only-I gtk+-2.0 libgnomeui-2.0 gl x11) \
   -bargs:Ada -E \
   -largs -Wl,--as-needed \
      $(shell DEB_BUILD_OPTIONS="$(DEB_BUILD_OPTIONS)" dpkg-buildflags --get LDFLAGS) \
   -gargs -R -p -s -we $(GPRBUILD_VERBOSE)


.NOTPARALLEL:
ifeq (,$(filter parallel=%,$(DEB_BUILD_OPTIONS)))
   GPRBUILD += -j$(shell getconf _NPROCESSORS_ONLN)
else
   GPRBUILD += -j$(patsubst parallel=%,%,$(filter parallel=%,$(DEB_BUILD_OPTIONS)))
endif


# We have to override the default gprbuild configuration, as we want
# to compile C sources with gnatgcc, which may be distinct from gcc.
GPRBUILD_CONFIG := $(GEN_DIR)/default.cgpr
gprbuild += --config=$(GPRBUILD_CONFIG)
$(GPRBUILD_CONFIG): | $(GEN_DIR)
	gprconfig --batch -o $@ \
          --target=$(shell gnatgcc -dumpmachine) \
          --config=C,$(shell gnatgcc -dumpversion) \
          --config=Ada


# Template to avoid redundant code for libraries.

define library_template
# 1: library name, as in libNAME.so.xxx
# 1_LDFLAGS: as in "-lfoo -lbar"
# 1_SOURCE_DIRS: as in src/generated src
# 1_WITHED_PROJECTS: for installed project, as in "gtkada otherproject"
# 1_TRAMPOLINE_LINTIAN_OVERRIDE: if not empty, a lintian override is generated
# 1_VERSIONED_GPR: if not empty, a versioned link points to the system gpr file
# 1_LANGUAGES: as in "Ada", "C"

$(1)_SOVERSION  := $(shell sed -n -r 's/^Package: lib$(1)([[:digit:].]+)$$/\1/p' debian/control)
$(1)_DEV_PKG    := $(shell sed -n -r 's/^Package: (lib$(1)[[:digit:].]+-dev)$$/\1/p' debian/control)
$(1)_LIB_PKG    := lib$(1)$$($(1)_SOVERSION)
$(1)_DBG_PKG    := lib$(1)-dbg
$(1)_SONAME     := lib$(1).so.$$($(1)_SOVERSION)


# Static library
$(1)_STATIC_LIB := $(GEN_DIR)/$(1)_static_lib/lib$(1).a

ifeq (,$(SKIP_STATIC))
override_dh_auto_build-arch: $$($(1)_STATIC_LIB)
override_dh_auto_install-arch::
	dh_install --package=$$($(1)_DEV_PKG) $$($(1)_STATIC_LIB) usr/lib/$(DEB_HOST_MULTIARCH)
	dh_strip --package=$$($(1)_DEV_PKG) --exclude=.a
endif

.PHONY: $$($(1)_STATIC_LIB) # always call gprbuild
$$($(1)_STATIC_LIB): $(GEN_DIR)/$(1)_static.gpr $(GPRBUILD_CONFIG) $$(patsubst %,$(GEN_DIR)/%_static.gpr,$$($(1)_WITHED_PROJECTS))
	$(GPRBUILD) $$<


# Dynamic library and ALI files.
$(1)_DYNAMIC_LIB := $(GEN_DIR)/$(1)_dynamic_lib/$$($(1)_SONAME)

override_dh_auto_build-arch: $$($(1)_DYNAMIC_LIB)
override_dh_auto_install-arch::
	dh_install --package=$$($(1)_LIB_PKG) $$($(1)_DYNAMIC_LIB) usr/lib/$(DEB_HOST_MULTIARCH)
	dh_install --package=$$($(1)_DEV_PKG) $(GEN_DIR)/$(1)_dynamic_lib/*.ali usr/lib/$(DEB_HOST_MULTIARCH)/ada/adalib/$(1)
	dh_link --package=$$($(1)_DEV_PKG) $(addprefix usr/lib/$(DEB_HOST_MULTIARCH)/,$$($(1)_SONAME) lib$(1).so)
	dh_strip --package=$$($(1)_LIB_PKG) --dbg-package=$$($(1)_DBG_PKG)

.PHONY: $$($(1)_DYNAMIC_LIB) # always call gprbuild
$$($(1)_DYNAMIC_LIB): $(GEN_DIR)/$(1)_dynamic.gpr $(GPRBUILD_CONFIG) $$(patsubst %,$(GEN_DIR)/%_dynamic.gpr,$$($(1)_WITHED_PROJECTS))
	$(GPRBUILD) $$<


# Sources
$(1)_SOURCES := $$(wildcard $$(foreach dir,$$($(1)_SOURCE_DIRS),$$(dir)/*.ad[sb] $$(dir)/*.[ch]))

override_dh_auto_install-arch::
	dh_install --package=$$($(1)_DEV_PKG) $$($(1)_SOURCES) usr/share/ada/adainclude/$(1)


# Build-time project files.

$(GEN_DIR)/$(1)_static.gpr $(GEN_DIR)/$(1)_dynamic.gpr: $(GEN_DIR)/$(1)_%.gpr : | $(GEN_DIR)
	rm -f $$@
	$$(patsubst %,echo 'with "%_$$*.gpr";' >> $$@;,$$($(1)_WITHED_PROJECTS))
	echo 'project $(1)_$$* is' >> $$@
	echo '  for Library_Name use "$(1)";' >> $$@
	echo '  for Library_Kind use "$$*";' >> $$@
	echo '  for Library_Dir use "$(1)_$$*_lib";' >> $$@
	echo '  for Source_Dirs use ("$$(shell echo $$(addprefix ../../,$$($(1)_SOURCE_DIRS)) | sed 's@ \+@", "@g')");' >> $$@
	echo '  for Object_Dir use "$(1)_$$*_obj";' >> $$@
	echo '  for Languages use ($$($(1)_LANGUAGES));' >> $$@
	echo '  for Library_Options use ("$$(shell echo $$($(1)_LDFLAGS) | sed 's@ \+@", "@g')");' >> $$@
	if test "$$*" = "dynamic"; then \
        echo '  for Library_Version use "$$($(1)_SONAME)";' >> $$@; \
        fi
	echo 'end $(1)_$$*;' >> $$@


# system-wide gnat project file

override_dh_auto_build-arch: $(GEN_DIR)/$(1).gpr
override_dh_auto_install-arch::
	dh_install --package=$$($(1)_DEV_PKG) $(GEN_DIR)/$(1).gpr usr/share/ada/adainclude

ifneq (,$$($(1)_VERSIONED_GPR))
override_dh_auto_build-arch: $(GEN_DIR)/$(1)2.gpr
override_dh_auto_install-arch::
	dh_install --package=$$($(1)_DEV_PKG) $(GEN_DIR)/$(1)2.gpr usr/share/ada/adainclude
endif

$(GEN_DIR)/$(1).gpr $(GEN_DIR)/$(1)2.gpr: $(GEN_DIR)/%.gpr: | $(GEN_DIR)
	rm -f $$@
	echo '--  This project file is designed to help build applications that use' >> $$@
	echo '--  $(1). Here is an example of how to use this project file:' >> $$@
	echo '--' >> $$@
	echo '--  with "$(1)";' >> $$@
	echo '--  project Example is' >> $$@
	echo '--     for Object_Dir use "obj";' >> $$@
	echo '--     for Exec_Dir use ".";' >> $$@
	echo '--     for Main use ("example");' >> $$@
	echo '--  end Example;' >> $$@
	echo '' >> $$@
	$$(patsubst %,echo 'with "%.gpr";' >> $$@;,$$($(1)_WITHED_PROJECTS))
	echo 'project $$* is' >> $$@
	echo '   for Library_Name use "$(1)";' >> $$@
	echo '   for Library_Kind use "dynamic";' >> $$@
	echo '   for Library_Dir use "/usr/lib/$(DEB_HOST_MULTIARCH)";' >> $$@
	echo '   for Source_Dirs use ("/usr/share/ada/adainclude/$(1)");' >> $$@
	echo '   for Library_ALI_Dir use "/usr/lib/$(DEB_HOST_MULTIARCH)/ada/adalib/$(1)";' >> $$@
	echo '   for Externally_Built use "true";' >> $$@
	echo '   package Linker is' >> $$@
	echo '      for Linker_Options use ("$$(shell echo $$($(1)_LDFLAGS) | sed 's@ \+@", "@g')");' >> $$@
	echo '   end Linker;' >> $$@
	echo 'end $$*;' >> $$@


# lintian override for executable stack

ifneq (,$$($(1)_TRAMPOLINE_LINTIAN_OVERRIDE))
override_dh_auto_build-arch: $(GEN_DIR)/$$($(1)_LIB_PKG)
override_dh_auto_install-arch::
	dh_install --package=$$($(1)_LIB_PKG) $(GEN_DIR)/$$($(1)_LIB_PKG) usr/share/lintian/overrides
endif

$(GEN_DIR)/$$($(1)_LIB_PKG): | $(GEN_DIR)
	echo '# gnat uses trampolines to implement Ada exceptions' >> $$@

=== debian/watch ===
# The latest gtkada source is available on
# http://libre.adacore.com/libre/download. The tarball download system is
# too complicated to be described in a watch file.
